/*
** $PROJECT: c.datatype
**
** $VER: tester.c 39.1 (25.11.95)
**
** by
**
** Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** (C) Copyright 1995
** All Rights Reserved !
**
** $HISTORY:
**
** 25.11.95 : 039.001 : initial
*/

#include <dos/dos.h>
#include <dos/dosextens.h>
#include <exec/types.h>
#include <exec/ports.h>
#include <exec/memory.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/cghooks.h>
#include <intuition/gadgetclass.h>
#include <exec/lists.h>
#include <exec/semaphores.h>
#include <exec/execbase.h>
#include <datatypes/datatypes.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/textclass.h>
#include <clib/alib_protos.h>
#include <clib/alib_stdio_protos.h>
#include <string.h>

#include <clib/macros.h>
#include <clib/dos_protos.h>
#include <clib/exec_protos.h>
#include <clib/datatypes_protos.h>
#include <clib/dtclass_protos.h>
#include <clib/intuition_protos.h>

#include <pragmas/dos_pragmas.h>
#include <pragmas/exec_sysbase_pragmas.h>
#include <pragmas/datatypes_pragmas.h>
#include <pragmas/dtclass_pragmas.h>
#include <pragmas/intuition_pragmas.h>

__saveds LONG main(void)
{
	struct Library *SysBase = *((struct Library **) 4L);
	struct Library *DataTypesBase;
	struct Library *IntuitionBase;
	struct Library *DOSBase;
	LONG retval = RETURN_OK;

	if((DOSBase = OpenLibrary("dos.library",39)) != NULL)
	{
		if((DataTypesBase = OpenLibrary("datatypes.library",39)) != NULL)
		{
			if((IntuitionBase = OpenLibrary("intuition.library",39)) != NULL)
			{
				LONG para[2] = {0,0};
				STRPTR *files;
				struct RDArgs *rdargs;

				if((rdargs = ReadArgs("FILES/M/A,QUIET/S",para,NULL)) != NULL)
				{
					struct GadgetInfo ginfo;
					struct DataType *dt;
					BPTR lock;
					BPTR error;

					/* get error stream */
					if((error = ((struct Process *) FindTask(NULL))->pr_CES) == NULL)
						error = Output();

					files = (STRPTR *) para[0];

					memset(&ginfo,0,sizeof(ginfo));

					/* simulate a GadgetInfo structure */
					if((ginfo.gi_Screen = LockPubScreen(NULL)) != NULL)
						ginfo.gi_DrInfo = GetScreenDrawInfo(ginfo.gi_Screen);

					while(*files != NULL)
					{
						if((lock = Lock(*files,SHARED_LOCK)) != NULL)
						{
							if((dt = ObtainDataTypeA(DTST_FILE,(APTR)lock,NULL)) != NULL)
							{
								if(!strcmp(dt->dtn_Header->dth_BaseName,"c"))
								{
									Object *obj;

									if(para[1] == 0)
										Printf("testing %s\n",*files);

									if((obj = NewDTObjectA(*files,NULL)) != NULL)
									{
										ULONG err  = 0;
										ULONG line = 0;
										DoMethod(obj,GM_LAYOUT,&ginfo,TRUE);

										if(GetDTAttrs(obj,DTA_Special,&err,
																DTA_UserData,&line,
																TAG_DONE) == 2 && err)
										{
											FPrintf(error,"%s: error at line %ld\n",*files,line);
											retval = RETURN_ERROR;
										}
										DisposeDTObject(obj);
									}
								}

								ReleaseDataType(dt);
							}

							UnLock(lock);
						}
						files++;
					}

					if(ginfo.gi_Screen != NULL)
					{
						if(ginfo.gi_DrInfo != NULL)
							FreeScreenDrawInfo(ginfo.gi_Screen,ginfo.gi_DrInfo);

						UnlockPubScreen(NULL,ginfo.gi_Screen);
					}
					FreeArgs(rdargs);
				}
				CloseLibrary(IntuitionBase);
			}
			CloseLibrary(DataTypesBase);
		}
		CloseLibrary(DOSBase);
	}

	return(retval);
}

