/*
** $PROJECT: dirdemo.datatype
**
** $VER: classbase.h 40.1 (08.09.96)
**
** by
**
** Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** (C) Copyright 1996
** All Rights Reserved !
**
** $HISTORY:
**
** 08.09.96 : 040.001 : initial
*/

/* ------------------------- include system stuff ------------------------- */

#define __USE_SYSBASE

#include <string.h>

#include <dos/dos.h>
#include <dos/dosextens.h>
#include <dos/dostags.h>
#include <exec/types.h>
#include <exec/ports.h>
#include <exec/memory.h>
#include <exec/lists.h>
#include <exec/execbase.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/gadgetclass.h>
#include <datatypes/datatypes.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/textclass.h>

#include <clib/macros.h>
#include <clib/alib_protos.h>
#include <clib/alib_stdio_protos.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/intuition_protos.h>
#include <clib/utility_protos.h>
#include <clib/datatypes_protos.h>
#include <pragmas/exec_sysbase_pragmas.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/utility_pragmas.h>
#include <pragmas/datatypes_pragmas.h>

/* --------------------------- include my stuff --------------------------- */

/* now include class specifics */
#include "class.h"

#include "register.h"
#include "debug.h"

#include "protos.h"

/* -------------------- include specific systems parts -------------------- */

#ifdef USE_GFXLIB
#include <clib/graphics_protos.h>
#include <pragmas/graphics_pragmas.h>
#endif
#ifdef USE_IFFPARSELIB
#include <clib/iffparse_protos.h>
#include <pragmas/iffparse_pragmas.h>
#endif

/* ------------------------------ structures ------------------------------ */

#ifndef USERCLASSBASEDATA
#define USERCLASSBASEDATA
#endif

struct ClassBase
{
   struct Library cb_Lib;
   UWORD          cb_Pad1;

   struct Library *cb_SysBase;
   struct Library *cb_DOSBase;
   struct Library *cb_IntuitionBase;
   struct Library *cb_UtilityBase;
#ifdef USE_GFXLIB
   struct Library *cb_GfxBase;
#endif
   struct Library *cb_DataTypesBase;
#ifdef SUPERCLASSLIBRARY
   struct Library *cb_SuperClassBase;
#endif

#ifdef USE_IFFPARSELIB
   struct Library *cb_IFFParseBase;
#endif

   BPTR           cb_SegList;
   Class          *cb_Class;

   USERCLASSBASEDATA
};

/* ---------------------------- library bases ----------------------------- */

#ifdef __SASC
#define SysBase                 cb->cb_SysBase
#define DOSBase                 cb->cb_DOSBase
#define UtilityBase             cb->cb_UtilityBase
#define IntuitionBase           cb->cb_IntuitionBase
#define GfxBase                 cb->cb_GfxBase
#define DataTypesBase           cb->cb_DataTypesBase
#define HyperTextDTClassBase    cb->cb_SuperClassBase
#define IFFParseBase            cb->cb_IFFParseBase
#endif

