/*
** $PROJECT: dirdemo.datatype
**
** $VER: dispatch.c 40.1 (08.09.96)
**
** by
**
** Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** (C) Copyright 1996
** All Rights Reserved !
**
** $HISTORY:
**
** 08.09.96 : 040.001 : initial
*/

/*FS*//* ------------------------------- include -------------------------------- */

#include "classbase.h"
/*FE*/

/*FS*//* ------------------------------- autodoc -------------------------------- */

/****** xxx.datatype/xxx.datatype ********************************************
*
*    NAME
*
*    FUNCTION
*
*    METHODS
*
*    SEE ALSO
*        hypertext.datatype, directory.datatype
*
******************************************************************************
*
*/
/*FE*/

/*FS*//* ------------------------------- defines -------------------------------- */

#define SET(msg)           ((struct opSet *) (msg))
/*FE*/

/*FS*//* ----------------------------- Preferences ------------------------------ */

/**** Prefs file ReadArgs() support
#define PREFS_TEMPLATE        "MYOPT/K,MYSWITCH/S,MYNUMBER/N"
struct Args
{
   STRPTR a_MyOpt;
   LONG a_MySwitch;
   LONG* a_MyNumber;
};
****/

#ifdef PREFS_TEMPLATE
static BOOL ReadPrefs(Class *cl,Object *obj,STRPTR file)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   struct DirData *data = INST_DATA(cl,obj);
   struct RDArgs *rdargs;
   struct RDArgs *args;
   BPTR fh;

   if((fh = Open(file,MODE_OLDFILE)) != NULL)
   {
      UBYTE buf[256];

      DB(("prefs file \"%s\" opened\n",file));
      if((rdargs = (struct RDArgs *) AllocDosObject(DOS_RDARGS,NULL)) != NULL)
      {
	 while(FGets(fh,buf,sizeof(buf)) != NULL)
	 {
	    struct Args para;
	    /* skip comment and empty lines, to speed up parsing */
	    if(buf[0] == ';' || buf[0] == '\n')
	       continue;

	    rdargs->RDA_Source.CS_Buffer = buf;
	    rdargs->RDA_Source.CS_Length = strlen(buf);
	    rdargs->RDA_Source.CS_CurChr = 0;

	    memset(&para,0,sizeof(struct Args));

	    if((args = ReadArgs(PREFS_TEMPLATE,(LONG *) &para,rdargs)) != NULL)
	    {
	       DB(("args at %lx\n",args));

	       if(para.a_MyOpt != NULL)
	       {
	       }

	       if(para.a_MySwitch)
	       {
	       }

	       if(para.a_MyNumber != NULL)
	       {
	       }

	       FreeArgs(args);
	    }
	 }
	 FreeDosObject(DOS_RDARGS , rdargs);
      }
      Close(fh);
   }

   return((BOOL) (fh == NULL));
}
#endif
/*FE*/

/*FS*//* --------------------------- class dispatcher --------------------------- */

ClassCall ULONG dispatcher(REGA0 Class *cl,REGA2 Object *obj,REGA1 Msg msg)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   ULONG retval = 0;

   switch(msg->MethodID)
   {
   case OM_NEW:
      {
	 Object *newobj;

	 if((newobj = (Object *) DoSuperMethodA(cl,obj,msg)) != NULL)
	 {
	    struct DataType *dt;
	    ULONG type;
	    BPTR handle;
	    APTR pool;


#ifdef PREFS_TEMPLATE
	    if(PROC(FindTask(NULL)->pr_HomeDir == NULL || ReadPrefs(cl,newobj,"PROGDIR:Prefs/DataTypes/xxx.prefs"))
	       ReadPrefs(cl,newobj,"ENV:DataTypes/xxx.prefs");
#endif
	    /* set directory attributes */
	    SetSuperAttrs(cl,newobj,
			  DIRDTA_Format,"%s @{b}%l@{ub} %c",
			  DIRDTA_SortBy,DIRSB_NAME,
			  DIRDTA_ParentEntry,FALSE,
			  TAG_DONE);


	    if(GetDTAttrs(newobj,
			  DTA_Handle,&handle,
			  DTA_SourceType,&type,
			  DTA_DataType,&dt,
			  HTDTA_Pool,&pool,
			  TAG_DONE) == 4 &&
			  handle != NULL && type == DTST_FILE &&
			  pool != NULL)
	    {
	       struct RDArgs *rdargs;

	       /* handle only ascii files */
	       switch(dt->dtn_Header->dth_Flags & DTF_TYPE_MASK)
	       {
	       case DTF_ASCII:
		  if((rdargs = AllocDosObject(DOS_RDARGS,NULL)) != NULL)
		  {
		     struct Args
		     {
			STRPTR a_Name;
			LONG *a_Size;
			STRPTR a_Comment;
		     } para;
		     struct DirDTEntry *entry;
		     UBYTE buf[100];

		     while(FGets(handle,buf,sizeof(buf)) != NULL)
		     {
			struct RDArgs *args;

			/* skip comments and empty lines */
			if(*buf == ';' || *buf == '#' || *buf == '\n')
			   continue;

			rdargs->RDA_Source.CS_Buffer = buf;
			rdargs->RDA_Source.CS_Length = strlen(buf);
			rdargs->RDA_Source.CS_CurChr = 0;

			if((args = ReadArgs("NAME/A,SIZE/N,COMMENT/F",(LONG *) &para,rdargs)) != NULL)
			{
			   LONG len = strlen(para.a_Name) + 1;

			   if(para.a_Comment != NULL)
			      len += strlen(para.a_Comment) + 1;

			   if((entry = AllocPooled(pool,sizeof(struct DirDTEntry) + len)) != NULL)
			   {
			      entry->de_FileName = (STRPTR) (entry + 1);
			      strcpy(entry->de_FileName,para.a_Name);

			      entry->de_Size     = (para.a_Size != NULL) ? *para.a_Size : 0;

			      if(para.a_Comment != NULL)
			      {
				 entry->de_Comment  = entry->de_FileName + strlen(entry->de_FileName) + 1;
				 strcpy(entry->de_Comment,para.a_Comment);
			      }

			      DoMethod(newobj,DIRDTM_INSERTENTRY,NULL,entry);
			   }
			   FreeArgs(args);
			}
		     }
		     FreeDosObject(DOS_RDARGS,rdargs);
		     retval = (ULONG) newobj;
		  } else
		     SetIoErr(ERROR_NO_FREE_STORE);
		  break;
	       default:
		  SetIoErr(ERROR_OBJECT_WRONG_TYPE);
	       }
	    } else
	       SetIoErr(ERROR_REQUIRED_ARG_MISSING);

	    if(retval == (ULONG) NULL)
	       CoerceMethod(cl,newobj,OM_DISPOSE);
	 }
      }
      break;
   case OM_DISPOSE:
      /* don't need to free any resource, if you use only the SuperClass
       * memory pool (HTDTA_Pool).
       */
      retval = DoSuperMethodA(cl,obj,msg);
      break;
   case OM_UPDATE:
   case OM_SET:
      /* Pass the attributes to the hypertext class and force a refresh
       * if we need it */
      if((retval = DoSuperMethodA (cl, obj, msg)) && (OCLASS (obj) == cl))
      {
	 struct RastPort *rp;

	 if((rp = ObtainGIRPort(SET(msg)->ops_GInfo)) != NULL)
	 {
	    /* send only a update message GREDRAW_UPDATE */
	    DoMethod(obj,GM_RENDER,SET(msg)->ops_GInfo,rp,GREDRAW_UPDATE);

	    ReleaseGIRPort (rp);
	 }

	 retval = 0;
      }
      break;
   default:
      retval = DoSuperMethodA(cl,obj,msg);
   }

   return retval;
}
/*FE*/

