#
# $PROJECT: Include Makefiles
#
# $VER: gcc.mk 0.1 (21.07.95)
#
# by
#
# Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
#
# (C) Copyright 1995
# All Rights Reserved !
#
# $HISTORY:
#
# 21.07.95 : 000.001 : initial
#

C++ = g++
CC  = gcc
CP  = copy

FLUSHLIB = flushlib

##############################################################################
#
# GNUMake GCC-C pattern rules
#
# These rules compiles every c and c++ source and puts the output to
# the OBJDIR directory
#

$(OBJDIR)/%.o: %.cc
	$(C++) $(GCCOPTS) $(GCCDEBUG) $(GCCOPTIMIZE) $< -c -o $@
	$(ARCHIVER)

$(OBJDIR)/%.o: %.c
	$(CC) $(GCCOPTS) $(GCCDEBUG) $(GCCOPTIMIZE) $< -c -o $@
	$(ARCHIVER)

##############################################################################
#
# make datatype, only if the DATATYPE varibale is specified
#

ifneq ($(DATATYPE)X,X)
$(DATATYPE) : $(OBJS)
	$(CC) $^ -o $@ -nostartfiles $(LDOPTS)
	$(CP) $@ $(DTYPEDEST)
	-$(FLUSHLIB) ${@F}
endif

##############################################################################
#
# make prototypes
#

protos:  $(DIRS) $(PROTOS)

$(PROTOS): $(CSRCS)
	c:swtools/mkproto $(CSRCS) TO $(PROTOS)

##############################################################################
#
# check in all files
#

checkin:
	ci -I -nV$(VERSION)_$(REVISION) -r -t-initial $(subst RCS,,$(wildcard *))

##############################################################################
#
# check out all files
#

checkout:
	$(CO) -l $(subst RCS/,,$(wildcard RCS/*))

##############################################################################
#
# make the object directory
#

$(DIRS):
	mkdir $@ all

##############################################################################
#
# make dependency include makefile
#

makedep:
	$(CC) -MM $(SRCS) $(GCCOPTS) >$(MAKEDEP)

