
/*FS*//* ------------------------------- include -------------------------------- */

#include "classbase.h"
/*FE*/

/*FS*//* ------------------------------- autodoc -------------------------------- */

/****** xxx.datatype/xxx.datatype ********************************************
*
*    NAME
*
*    FUNCTION
*
*    METHODS
*
*    SEE ALSO
*        hypertext.datatype
*
******************************************************************************
*
*/
/*FE*/

/*FS*//* ------------------------------- defines -------------------------------- */

#define BUFFER_SIZE        256

#define GAD(o)             ((struct Gadget *) (o))

#define GPL(msg)           ((struct gpLayout *) (msg))
#define SET(msg)           ((struct opSet *) (msg))
/*FE*/

/*FS*//* ----------------------------- Preferences ------------------------------ */

/**** Prefs file ReadArgs() support
#define PREFS_TEMPLATE        "MYOPT/K,MYSWITCH/S,MYNUMBER/N"
struct Args
{
   STRPTR a_MyOpt;
   LONG a_MySwitch;
   LONG* a_MyNumber;
};
****/

#ifdef PREFS_TEMPLATE
static BOOL ReadPrefs(Class *cl,Object *obj,STRPTR file)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   struct DirData *data = INST_DATA(cl,obj);
   struct RDArgs *rdargs;
   struct RDArgs *args;
   BPTR fh;

   if((fh = Open(file,MODE_OLDFILE)) != NULL)
   {
      UBYTE buf[256];

      DB(("prefs file \"%s\" opened\n",file));
      if((rdargs = (struct RDArgs *) AllocDosObject(DOS_RDARGS,NULL)) != NULL)
      {
         while(FGets(fh,buf,sizeof(buf)) != NULL)
         {
            struct Args para;
            /* skip comment and empty lines, to speed up parsing */
            if(buf[0] == ';' || buf[0] == '\n')
               continue;

            rdargs->RDA_Source.CS_Buffer = buf;
            rdargs->RDA_Source.CS_Length = strlen(buf);
            rdargs->RDA_Source.CS_CurChr = 0;

            memset(&para,0,sizeof(struct Args));

            if((args = ReadArgs(PREFS_TEMPLATE,(LONG *) &para,rdargs)) != NULL)
            {
               DB(("args at %lx\n",args));

               if(para.a_MyOpt != NULL)
               {
               }

               if(para.a_MySwitch)
               {
               }

               if(para.a_MyNumber != NULL)
               {
               }

               FreeArgs(args);
            }
         }
         FreeDosObject(DOS_RDARGS , rdargs);
      }
      Close(fh);
   }

   return((BOOL) (fh == NULL));
}
#endif
/*FE*/

/*FS*//* ---------------------------- notify object ----------------------------- */

ULONG NotifyAttrs(Object *o,void *ginfo,ULONG flags,ULONG tag1,...)
{
    return(DoMethod(o, OM_NOTIFY, &tag1, ginfo, flags));
}
/*FE*/

/*FS*//* -------------------------- attribute support --------------------------- */

ULONG om_get(Class *cl,Object *obj,struct opGet *msg)
{
   struct xxxData *data = INST_DATA(cl,obj);

   switch(msg->opg_AttrID)
   {
    /**** For exmaple :
   case HTDTA_LoadBuffer:
      *msg->opg_Storage = FALSE;
      break;
    ***/
   default:
      return DoSuperMethodA(cl,obj,(Msg) msg);
   }

   return 1;
}
ULONG om_set(Class *cl,Object *obj,struct opSet *msg)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   struct xxxData *data = INST_DATA(cl,obj);
   struct TagItem *tstate = msg->ops_AttrList;
   struct TagItem *tag;
   ULONG rc = 0;

   while((tag = NextTagItem(&tstate)) != NULL)
   {
      rc++;
      switch(tag->ti_Tag)
      {
      case HTDTA_xxx:
         break;
      default:
         rc--;
      }
   }

   return rc;
}
/*FE*/

/*FS*//* --------------------------- class dispatcher --------------------------- */

ClassCall ULONG dispatcher(REGA0 Class *cl,REGA2 Object *obj,REGA1 Msg msg)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   ULONG retval = 0;

   switch(msg->MethodID)
   {
   case OM_NEW:
      {
         Object *newobj;

         if((newobj = (Object *) DoSuperMethodA(cl,obj,msg)) != NULL)
         {
            struct xxxData *data = INST_DATA(cl,newobj);

            DB(("After OM_NEW DoSuperMethodA()\n"));

            /* initialize the instance data here */

#ifdef PREFS_TEMPLATE
            if(PROC(FindTask(NULL)->pr_HomeDir == NULL || ReadPrefs(cl,newobj,"PROGDIR:Prefs/DataTypes/xxx.prefs"))
               ReadPrefs(cl,newobj,"ENV:DataTypes/xxx.prefs");
#endif

            om_set(cl,newobj,(struct opSet *) msg);

            retval = (ULONG) newobj;
         }
      }
      break;
   case OM_DISPOSE:
      /* don't need to free any resource, if you use only the SuperClass
       * memory pool (HTDTA_Pool).
       */
      retval = DoSuperMethodA(cl,obj,msg);
      break;
   case OM_GET:
      retval = om_get(cl,obj,(struct opGet *) msg);
      break;
   case OM_UPDATE:
   case OM_SET:
      retval = om_set(cl,obj,(struct opSet *) msg);
      /* Pass the attributes to the hypertext class and force a refresh
       * if we need it */
      if((retval += DoSuperMethodA (cl, obj, msg)) && (OCLASS (obj) == cl))
      {
         struct RastPort *rp;

         if((rp = ObtainGIRPort(SET(msg)->ops_GInfo)) != NULL)
         {
            /* send only a update message GREDRAW_UPDATE */
            DoMethod(obj,GM_RENDER,SET(msg)->ops_GInfo,rp,GREDRAW_UPDATE);

            ReleaseGIRPort (rp);
         }

         retval = 0;
      }
      break;
   case GM_LAYOUT:
      /* Tell everyone that we are busy doing things */
      NotifyAttrs (obj, GPL(msg)->gpl_GInfo, NULL,
                        GA_ID,       GAD(obj)->GadgetID,
                        DTA_Busy,    TRUE,
                        TAG_DONE);

      /* NOTE: this is different from current known datatypes implementations
       * but its necessary! The hypertext.datatype depends on it.
       * So only do a AsyncLayout, when the SuperClass returns a zero.
       */
      if((retval = DoSuperMethodA (cl, obj, msg)) == 0)
      {
         /* We need to do this one asynchronously */
         retval += DoAsyncLayout (obj, (struct gpLayout *) msg);
      }
      break;
   case DTM_PROCLAYOUT:
      /* Tell everyone that we are busy doing things */
      NotifyAttrs (obj, GPL(msg)->gpl_GInfo, NULL,
                        GA_ID,       GAD(obj)->GadgetID,
                        DTA_Busy,    TRUE,
                        TAG_DONE);

      /* Let the super-class partake and then fall through to our layout method */
      DoSuperMethodA (cl, obj, msg);
   case DTM_ASYNCLAYOUT:
      /* Layout the text */
      retval = layout(cl, obj, GPL(msg));
      break;
   default:
      retval = DoSuperMethodA(cl,obj,msg);
   }

   return retval;
}
/*FE*/

/*FS*//* -------------------------------- layout -------------------------------- */

ULONG layout(Class *cl, Object *obj, struct gpLayout *msg)
{
   struct ClassBase *cb = (struct ClassBase *) cl->cl_UserData;
   struct xxxData *data = INST_DATA(cl,obj);
   APTR pool;
   ULONG maxwidth = 0;
   ULONG total    = 0;
   ULONG th = 0,tv = 0;

   /* attributes obtained from super-class */
   struct IBox *domain;
   struct TextFont *font;
   STRPTR title;

   DB(("xxx layout , obj : %lx!\n",obj));

   /* Get all the attributes that we are going to need for a successful layout */
   if(GetDTAttrs(obj,
                 DTA_TextFont,      (ULONG) &font,
                 DTA_ObjName,       (ULONG) &title,
                 DTA_Domain,        (ULONG) &domain,
                 DTA_TopHoriz,      (ULONG) &th,
                 DTA_TopVert,       (ULONG) &tv,
                 DTA_Handle,        (ULONG) &handle,
                 TAG_DONE) == 6 && pool != NULL)
   {
      ULONG hunit,vunit;
      ULONG hvis,vvis;

      BOOL abort = FALSE;
      struct HTSegInfo *seginfo;

      hunit = font->tf_XSize;
      vunit = font->tf_YSize;
      hvis  = domain->Width  / hunit;
      vvis  = domain->Height / vunit;

      DB(("before OBTAIN object\n"));
      /* lock datatype object */
      DoMethod(obj,HTDTM_OBTAIN);


      DB(("before AllocSegInfo()\n"));
      /* We only need to perform layout if this is the initial layout call. We
       * need also a SegInfo structure !
       */
      if(msg->gpl_Initial && (seginfo = AllocSegInfo(HTDTSIA_Pool,pool,
                                                     HTDTSIA_Object,obj,
                                                     HTDTSIA_GadgetInfo,msg->gpl_GInfo,
                                                     TAG_DONE)) != NULL)
      {
         struct HTConvInfo *convinfo;
         struct TagItem tags[5];
         STRPTR fmtbuf;
         STRPTR buf;

         DB(("before AllocPooled()\n"));
         if((buf = AllocPooled(pool,2*BUFFER_SIZE)) != NULL)
         {
            fmtbuf = buf + BUFFER_SIZE;

            /* AllocConvInfoA() set up defaults */
            tags[0].ti_Tag  = HTDTSA_LayoutFlags;
            tags[1].ti_Tag  = HTDTSA_FgPen;
            tags[2].ti_Tag  = HTDTSA_BgPen;
            tags[3].ti_Tag  = HTDTSA_Style;
            tags[4].ti_Tag  = TAG_DONE;

            convinfo = AllocConvInfoA(seginfo,tags,NULL);


            /* insert here your code to convert your data into internal
             * hypertext.datatype representation using AllocSegment()
             */

            if(convinfo != NULL)
               FreeConvInfo(convinfo);

            FreePooled(pool,buf,2*BUFFER_SIZE);
         }
         FreeSegInfo(seginfo);
      }

      /* these values must be set explicitly
       * possible error in datatypesclass ?
       */
      {
         struct DTSpecialInfo *si = (struct DTSpecialInfo *) GAD(obj)->SpecialInfo;

         si->si_VisVert  = vvis;
         si->si_TotVert  = total;

         si->si_VisHoriz = hvis;
         si->si_TotHoriz = maxwidth;
         si->si_VertUnit = vunit;
         si->si_HorizUnit= hunit;
      }

      if(abort == FALSE)
      {
         /* layout the linked list */
         total = DoMethod(obj,HTDTM_LAYOUT,msg->gpl_GInfo,NULL,msg->gpl_Initial);

         GetAttr(DTA_TotalHoriz,obj,&maxwidth);
      }

      /* release (hypertext) datatype object */
      DoMethod(obj,HTDTM_RELEASE);

      DB(("after release()\n"));

      /* Were we aborted? */
      if(abort == FALSE)
      {
         /* Not aborted, so tell the world of our newest attributes */
         NotifyAttrs(obj, msg->gpl_GInfo, 0,
                          GA_ID,                   GAD(obj)->GadgetID,

                          DTA_VisibleVert,         vvis,
                          DTA_TotalVert,           total,
                          DTA_NominalVert,         25 * vunit,
                          DTA_VertUnit,            vunit,

                          DTA_VisibleHoriz,        hvis,
                          DTA_TotalHoriz,          maxwidth,
                          DTA_NominalHoriz,        60 * hunit,
                          DTA_HorizUnit,           hunit,

                          DTA_TopHoriz,            th,
                          DTA_TopVert,             tv,

                          DTA_Title,               title,
                          DTA_Busy,                FALSE,
                          DTA_Sync,                TRUE,
                          TAG_DONE);
      }
   }

   return total;
}
/*FE*/

