
;---------------------------------------------------------------------------

	INCLUDE "exec/types.i"
	INCLUDE "exec/libraries.i"
	INCLUDE "exec/lists.i"
	INCLUDE "exec/alerts.i"
	INCLUDE "exec/initializers.i"
	INCLUDE "exec/resident.i"
	INCLUDE "libraries/dos.i"

	INCLUDE "xxx_rev.i"

;---------------------------------------------------------------------------

	XREF    _LibInit
	XREF    _LibOpen
	XREF    _LibClose
	XREF    _LibExpunge
	XREF    _ObtainEngine

	XREF    _LibInitTable

	SECTION CODE

;---------------------------------------------------------------------------

	XDEF    LibReserved
	XDEF    ENDCODE
	XDEF    _LibDataTable
	XDEF    _LibFuncTable

;---------------------------------------------------------------------------

; First executable location, must return an error to the caller
Start:
	moveq   #-1,d0
	rts

;-----------------------------------------------------------------------

ROMTAG:
	DC.W    RTC_MATCHWORD           ; UWORD RT_MATCHWORD
	DC.L    ROMTAG                  ; APTR  RT_MATCHTAG
	DC.L    ENDCODE                 ; APTR  RT_ENDSKIP
	DC.B    RTF_AUTOINIT            ; UBYTE RT_FLAGS
	DC.B    VERSION                 ; UBYTE RT_VERSION
	DC.B    NT_LIBRARY              ; UBYTE RT_TYPE
	DC.B    0                       ; BYTE  RT_PRI
	DC.L    LibName                 ; APTR  RT_NAME
	DC.L    LibId                   ; APTR  RT_IDSTRING
	DC.L    _LibInitTable           ; APTR  RT_INIT

LibName NAME
LibId   VSTRING

	CNOP    0,4

V_DEF   MACRO
	DC.W    \1+(*-_LibFuncTable)
	ENDM

_LibFuncTable:
	DC.W    -1
	V_DEF   _LibOpen
	V_DEF   _LibClose
	V_DEF   _LibExpunge
	V_DEF   LibReserved

	V_DEF   _ObtainEngine

	DC.W   -1

_LibDataTable:
	INITBYTE   LN_TYPE,NT_LIBRARY
	INITLONG   LN_NAME,LibName
	INITBYTE   LIB_FLAGS,(LIBF_SUMUSED!LIBF_CHANGED)
	INITWORD   LIB_VERSION,VERSION
	INITWORD   LIB_REVISION,REVISION
	INITLONG   LIB_IDSTRING,LibId
	DC.W       0

	CNOP    0,4

;-----------------------------------------------------------------------

LibReserved:
	moveq   #0,d0
	rts

;-----------------------------------------------------------------------

ENDCODE:

	END

