
/*
**
**  $VER: markabletextdtclass.c 1.2 (27.9.96)
**  markabletextdtclass 1.0
**
**  main file
**
**  (C) Copyright 1996 by Roland 'Gizzy' Mainz
**          All Rights Reserved
**
*/

/* amiga includes */
#include <exec/types.h>
#include <exec/memory.h>
#include <exec/execbase.h>
#include <dos/dostags.h>
#include <intuition/icclass.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/textclass.h>

/* amiga prototypes */
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/intuition_protos.h>
#include <clib/datatypes_protos.h>
#include <clib/dtclass_protos.h>
#include <clib/alib_protos.h>

/* amiga pragmas */
#include <pragmas/exec_pragmas.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/datatypes_pragmas.h>
#include <pragmas/dtclass_pragmas.h>

/* ANSI includes */
#include <string.h>

/* version string */
#include "markabletextdtclass_rev.h"

/* misc defines */
#ifndef NAME
#define NAME "markabletextdtclass"
#endif /* !NAME */

/* SASC specific defines */
#define DISPATCHERFLAGS __saveds __asm
#define REGARGS __asm
#define REGA0 register __a0
#define REGA1 register __a1
#define REGA2 register __a2

/* version_string */
STRPTR versionstring = VERSTAG;

#define V( x )      ((VOID *)(x))
#define G( o )      ((struct Gadget *)(o))
#define EXTG( o )   ((struct ExtGadget *)(o))

#define XTAG( expr, tagid ) ((Tag)((expr)?(tagid):(TAG_IGNORE)))

long main_retval,
     main_retval2;

extern struct ExecBase *SysBase;
extern struct Library  *DOSBase;

struct ClassBase
{
    struct ExecBase *cb_SysBase;
    struct Library  *cb_IntuitionBase;
    struct Library  *cb_DataTypesBase;
};

/* instance data */
struct MarkableTextDTClassInstData
{
    ULONG *mtcid_Methods;     /* If NULL => patch disabled (possibly in directory.datatype,
                               * which includes the same "mark" workaround).
                               */
    BOOL   mtcid_InMarkMode;
};


const
ULONG markabletextdtclass_includemethods[] =
{
    DTM_SELECT,
    DTM_CLEARSELECTED,
    GM_GOACTIVE,
    GM_HANDLEINPUT,
    GM_GOINACTIVE,
    OM_NEW,
    OM_DISPOSE,
    OM_UPDATE,
    OM_SET,
    (~0UL)
};


const
ULONG markabletextdtclass_excludemethods[] =
{
    (~0UL)
};


/* prototypes */
DISPATCHERFLAGS ULONG          Dispatch( REGA0 struct IClass *, REGA2 Object *o, REGA1 Msg );
                ULONG         *CopyDTSupportedMethods( struct ClassBase *, Object *, ULONG *, ULONG * );
                ULONG          NumMethods( ULONG * );
                ULONG         *FindMethod( ULONG *, ULONG );
                ULONG          notifyAttrChanges( Object *, struct GadgetInfo *, ULONG, Tag, ... );

struct IClass *MyTextDTClass = NULL;


int main( void )
{
    struct ClassBase *cb;

    main_retval2 = 0L;
    main_retval = RETURN_OK;

    if( (SysBase -> LibNode . lib_Version) >= 39UL )
    {
      if( cb = (struct ClassBase *)AllocMem( (ULONG)sizeof( struct ClassBase ), MEMF_PUBLIC ) )
      {
        cb -> cb_SysBase = SysBase;

#define SysBase       (cb -> cb_SysBase)
#define IntuitionBase (cb -> cb_IntuitionBase)
#define DataTypesBase (cb -> cb_DataTypesBase)

        if( cb -> cb_IntuitionBase = OpenLibrary( "intuition.library", 39UL ) )
        {
          if( cb -> cb_DataTypesBase = OpenLibrary( "datatypes.library", 39UL ) )
          {
            struct Library *DTClassBase;

            if( DTClassBase = OpenLibrary( "datatypes/text.datatype", 39UL ) )
            {
              /* Avoid usage of this tool when using text.datatype > V40 */
              if( (DTClassBase -> lib_Version) <= 40U )
              {
                struct IClass *TextDTClass;

                if( TextDTClass = ObtainEngine() )
                {
                  ClassID oldclassid;

                  oldclassid = TextDTClass -> cl_ID;
                  TextDTClass -> cl_ID = "non_markable_text.datatype";

                  if( MyTextDTClass = MakeClass( TEXTDTCLASS, NULL, TextDTClass, (ULONG)sizeof( struct MarkableTextDTClassInstData ), 0UL ) )
                  {
                    MyTextDTClass -> cl_Dispatcher.h_Entry = (HOOKFUNC)Dispatch;
                    MyTextDTClass -> cl_UserData           = (ULONG)cb;

                    AddClass( MyTextDTClass );

                    Wait( SIGBREAKF_CTRL_C );

                    RemoveClass( MyTextDTClass );

                    while( !FreeClass( MyTextDTClass ) )
                      Delay( TICKS_PER_SECOND );
                  }
                  else
                  {
                    Printf( "can't make new text.datatype class !\n" );

                    main_retval2 = ERROR_NO_FREE_STORE;
                    main_retval  = RETURN_FAIL;
                  }

                  TextDTClass -> cl_ID = oldclassid;
                }
                else
                {
                  Printf( "can't obtain text.datatype\n" );

                  main_retval2 = ERROR_NO_FREE_STORE;
                  main_retval  = RETURN_FAIL;
                }
              }
              else
              {
                Printf( "text.datatype > V40 not supported\n" );

                main_retval2 = ERROR_OBJECT_WRONG_TYPE;
                main_retval  = RETURN_FAIL;
              }

              CloseLibrary( DTClassBase );
            }
            else
            {
              Printf( "can't open text.datatype\n" );

              main_retval2 = ERROR_NO_FREE_STORE;
              main_retval  = RETURN_FAIL;
            }

            CloseLibrary( (cb -> cb_DataTypesBase) );
          }
          else
          {
            Printf( "can't open datatypes.library\n" );

            main_retval2 = ERROR_NO_FREE_STORE;
            main_retval  = RETURN_FAIL;
          }

          CloseLibrary( (cb -> cb_IntuitionBase) );
        }
        else
        {
          Printf( "can't open intuition.library\n" );

          main_retval2 = ERROR_NO_FREE_STORE;
          main_retval  = RETURN_FAIL;
        }

        FreeMem( (APTR)cb, (ULONG)sizeof( struct ClassBase ) );
      }
      else
      {
        main_retval2 = ERROR_NO_FREE_STORE;
        main_retval  = RETURN_FAIL;
      }
    }
    else
    {
      main_retval2 = 0L;
      main_retval  = RETURN_FAIL;
    }

    PrintFault( main_retval2, NAME );

    SetIoErr( main_retval2 );

    return( main_retval );
}


DISPATCHERFLAGS
ULONG Dispatch( REGA0 struct IClass *cl, REGA2 Object *o, REGA1 Msg msg )
{
    struct ClassBase                   *cb = (struct ClassBase *)(cl -> cl_UserData);
    struct MarkableTextDTClassInstData *mtcid;
    ULONG                               retval = 0UL;

    switch( msg -> MethodID )
    {
        case OM_NEW:
        {
            if( retval = DoSuperMethodA( cl, o, msg ) )
            {
              /* Get a pointer to the object data */
              mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, retval );

              /* Check if the we're running inside a "directory.datatype" object
               * TRUE  => disable patch => mtcid -> mtcid_Methods = NULL;
               * FALSE => set up methods table
               */
              if( strcmp( (OCLASS( (Object *)retval ) -> cl_ID), "directory.datatype" ) )
              {
                /* Create array of supported methods (see OM_GET) */
                if( !(mtcid -> mtcid_Methods = CopyDTSupportedMethods( cb, (Object *)retval, (ULONG *)markabletextdtclass_includemethods, (ULONG *)markabletextdtclass_excludemethods )) )
                {
                  /* Can't build DTA_Methods list */
                  CoerceMethod( cl, (Object *)retval, OM_DISPOSE );
                  retval = 0UL;

                  SetIoErr( ERROR_NO_FREE_STORE );
                }
              }
            }
        }
            break;

        case OM_DISPOSE:
        {
            mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, o );

            /* Free methods array */
            FreeVec( (mtcid -> mtcid_Methods) );

            DoSuperMethodA( cl, o, msg );
        }
            break;

        case OM_GET:
        {
            mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, o );

            /* Redefine DTA_Methods to reflect all supported methods */
            if( ((((struct opGet *)msg) -> opg_AttrID) == DTA_Methods) && (mtcid -> mtcid_Methods) )
            {
              *(((struct opGet *)msg) -> opg_Storage) = (ULONG)(mtcid -> mtcid_Methods);

              retval = 1UL;
            }
            else
            {
              retval = DoSuperMethodA( cl, o, msg );
            }
        }
            break;

        case OM_UPDATE:
        case OM_SET:
        {
            /* Avoid OM_NOTIFY loops */
            if( DoMethod( o, ICM_CHECKLOOP ) )
            {
              break;
            }

            /* Pass the attributes to the text class and force a refresh
             * if we need it
             */
            if( (retval = DoSuperMethodA( cl, o, msg )) && (OCLASS( o ) == cl) )
            {
              struct RastPort *rp;

              /* Get a pointer to the rastport */
              if( rp = ObtainGIRPort( (((struct opSet *)msg) -> ops_GInfo) ) )
              {
                struct gpRender gpr;

                /* Force a redraw */
                gpr . MethodID   = GM_RENDER;
                gpr . gpr_GInfo  = ((struct opSet *)msg) -> ops_GInfo;
                gpr . gpr_RPort  = rp;
                gpr . gpr_Redraw = GREDRAW_UPDATE;

                DoMethodA( o, (Msg)(&gpr) );

                /* Release the temporary rastport */
                ReleaseGIRPort( rp );
              }

              retval = 0UL;
            }
        }
            break;

        case GM_GOACTIVE:
        case GM_HANDLEINPUT:
        {
            struct DTSpecialInfo *si  = (struct DTSpecialInfo *)(G( o ) -> SpecialInfo);
            struct gpInput       *gpi = (struct gpInput *)msg;

            mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, o );

            /* Patch enabled ? */
            if( mtcid -> mtcid_Methods )
            {
              /* Check if the user starts marking */
              if( (mtcid -> mtcid_InMarkMode) == FALSE )
              {
                if( (si -> si_Flags) & DTSIF_DRAGSELECT )
                {
                  mtcid -> mtcid_InMarkMode = TRUE;

                  /* Clear previous marked area */
                  DoMethod( o, DTM_CLEARSELECTED, (gpi -> gpi_GInfo) );
                }
              }
            }

            retval = DoSuperMethodA( cl, o, msg );
        }
            break;

        case GM_GOINACTIVE:
        {
            struct gpGoInactive *gpgi = (struct gpGoInactive *)msg;

            mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, o );

            retval = DoSuperMethodA( cl, o, msg );

            /* Patch enabled ? */
            if( mtcid -> mtcid_Methods )
            {
              /* If we were in mark mode... */
              if( mtcid -> mtcid_InMarkMode )
              {
                struct gpLayout gpl;

                mtcid -> mtcid_InMarkMode = FALSE;

                /* Do size layout (and send DTA_Sync to force a refresh) */
                gpl . MethodID    = GM_LAYOUT;
                gpl . gpl_GInfo   = gpgi -> gpgi_GInfo;
                gpl . gpl_Initial = 0L;

                DoMethodA( o, (Msg)(&gpl) );

                notifyAttrChanges( o, (gpgi -> gpgi_GInfo), 0UL,
                                   GA_ID,    (ULONG)(G( o ) -> GadgetID),
                                   DTA_Sync, 1UL,
                                   TAG_DONE );
              }
            }
        }
            break;

        case DTM_CLEARSELECTED:
        {
            mtcid = (struct MarkableTextDTClassInstData *)INST_DATA( cl, o );

            /* Patch enabled ? */
            if( mtcid -> mtcid_Methods )
            {
              struct IBox     *selectdomain;
              struct RastPort *rp;

              /* Put my "magic" "nothing selected" value into DTA_SelectDomain and
               * remove the DTSIF_HIGHLIGHT flag
               */
              if( GetAttr( DTA_SelectDomain, o, (ULONG *)(&selectdomain) ) == 1UL )
              {
                if( selectdomain )
                {
                  static const struct IBox  all_selected = { ~0, ~0, ~0, ~0 };

                  SetAttrs( o, DTA_SelectDomain, (&all_selected), TAG_DONE );
                }

                ((struct DTSpecialInfo *)(G( o ) -> SpecialInfo)) -> si_Flags &= ~DTSIF_HIGHLIGHT;
              }

              /* Get a pointer to the rastport */
              if( rp = ObtainGIRPort( (((struct dtGeneral *)msg) -> dtg_GInfo) ) )
              {
                struct gpRender gpr;

                /* Force a redraw */
                gpr . MethodID   = GM_RENDER;
                gpr . gpr_GInfo  = ((struct dtGeneral *)msg) -> dtg_GInfo;
                gpr . gpr_RPort  = rp;
                gpr . gpr_Redraw = GREDRAW_REDRAW;

                DoMethodA( o, (Msg)(&gpr) );

                /* Release the temporary rastport */
                ReleaseGIRPort( rp );
              }
            }
#ifdef COMMENTED_OUT
            else
            {
              retval = DoSuperMethodA( cl, o, msg );
            }
#endif /* COMMENTED_OUT */
        }
            break;

        /* Let the superclass handle everything else */
        default:
        {
            retval = DoSuperMethodA( cl, o, msg );
        }
            break;
    }

    return( retval );
}


ULONG *CopyDTSupportedMethods( struct ClassBase *cb, Object *o, ULONG *includemethods, ULONG *excludemethods )
{
    if( o )
    {
      ULONG *methods;

      if( methods = GetDTMethods( o ) )
      {
        ULONG  numincludemethods,
               nummethods;

        ULONG *copymethods;

        nummethods        = NumMethods( methods );
        numincludemethods = NumMethods( includemethods );

        if( copymethods = (ULONG *)AllocVec( ((nummethods + numincludemethods + 2UL) * sizeof( ULONG )), (MEMF_PUBLIC | MEMF_CLEAR) ) )
        {
          ULONG *x;

          /* Copy methods, including their terminator */
          memcpy( (void *)copymethods, (void *)methods, (size_t)((nummethods + 1UL) * sizeof( ULONG )) );

          if( includemethods )
          {
            /* Find terminator (== ~0UL) of copymethods */
            if( x = FindMethod( copymethods, (~0UL) ) )
            {
              memcpy( (void *)x, (void *)includemethods, (size_t)((numincludemethods + 1UL) * sizeof( ULONG )) );
            }
          }

          if( excludemethods )
          {
            while( (*excludemethods) != (~0UL) )
            {
              if( x = FindMethod( copymethods, (*excludemethods) ) )
              {
                *x = OM_NEW;
              }

              excludemethods++;
            }
          }

          return( copymethods );
        }
      }
    }

    return( NULL );
}


ULONG NumMethods( ULONG *methods )
{
    ULONG num = 0UL;

    if( methods )
    {
      while( (*methods) != (~0UL) )
      {
        methods++;
        num++;
      }
    }

    return( num );
}


ULONG *FindMethod( ULONG *methods, ULONG MethodID )
{
    if( methods )
    {
      while( ((*methods) != (~0UL)) && ((*methods) != MethodID) )
      {
        methods++;
      }

      if( (*methods) == MethodID )
      {
        return( methods );
      }
    }

    return( NULL );
}


ULONG notifyAttrChanges( Object *o, struct GadgetInfo *ginfo, ULONG flags, Tag tag1, ... )
{
    struct opUpdate opu;

    opu . MethodID     = OM_NOTIFY;
    opu . opu_AttrList = (struct TagItem *)(&tag1);
    opu . opu_GInfo    = ginfo;
    opu . opu_Flags    = flags;

    return( DoMethodA( o, (Msg)(&opu) ) );
}


