#ifndef DEBUG_H
#define DEBUG_H

/* debug.h
**
** $VER: debug.h 1.0 (22.10.96)
**
** Original by
**   Stefan Ruppert , Windthorststrae 5 , 65439 Flrsheim , GERMANY
**
*/

#ifdef DEBUG

extern void kprintf(char *fmt,...);
#define bprintf		kprintf

#define D(x)	x
#define DPUT(x)	bprintf("  "); bprintf x
#define DB(x)   { bprintf(__FILE__ "(%4ld):" __FUNC__ "() :\n  ",__LINE__); \
                  bprintf x; \
                }

#define ENTERING	bprintf("Entering " __FUNC__ "()\n")
#define LEAVING		bprintf("Leaving " __FUNC__ "()\n")


#else

#define D(x)
#define DPUT(x)
#define DB(x)
#define ENTERING
#define LEAVING

#endif

#endif   /* DEBUG_H */

