
******************************************************************************
*
* NewIcon Datatype
*
* Written by Pascal Hurni
*
******************************************************************************
* TestProximity.asm
*
*

	XDEF	_TestProximity


	SECTION	Code

;---------------------------------------------------------------;
; Each gun is 12-bit right justified : $0XXX
;
; Inputs:	D1	First R gun
;		D2	First G gun
;		D3	First B gun
;		D5	Second R gun
;		D6	Second G gun
;		D7	Second B gun
;
; Outputs:	D0	Proximity factor
;
;---------------------------------------------------------------;

_TestProximity

		movem.w	D2-D3/D5-D7,-(SP)

		sub.w	D1,D5
		bpl.b	LB_5714
		neg.w	D5
LB_5714		sub.w	D2,D6
		bpl.b	LB_571A
		neg.w	D6
LB_571A		sub.w	D3,D7
		bpl.b	LB_5720
		neg.w	D7
LB_5720		cmp.w	D6,D5
		bgt.b	LB_5726
		exg	D5,D6
LB_5726		cmp.w	D7,D5
		bgt.b	LB_572C
		exg	D7,D5
LB_572C		cmp.w	D7,D6
		bgt.b	LB_5732
		exg	D7,D6
LB_5732		lsr.w	#1,D6
		lsr.w	#2,D7
		moveq	#$00,D0
		move.w	D5,D0
		add.w	D6,D0
		add.w	D7,D0

		movem.w	(SP)+,D2-D3/D5-D7

		rts

	END

